<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref } from 'vue';
import ImageMasker from '@/components/general/ImageMasker.vue';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';

defineProps<{
    image: string
}>();
const maskedImage = ref();
const prompt = ref('');


const emits = defineEmits<{
    (e: 'submit', maskedImage:string, prompt:string):void,
    (e: 'close'):void
}>();

const handleSubmit = ()=>{
    emits('submit', maskedImage.value, prompt.value);
};

const handleClose = ()=>{
    emits('close');
};

const handleMaskerChange = (image:string)=>{
    maskedImage.value = image;
};

</script>
<template>
    <Modal :header="$t('ai.image.mask.header')" @submit="handleSubmit" :labelSubmit="$t('ai.chat.send.button')" :disableSubmit="prompt.length===0" :labelCancel="$t('general.buttons.cancel')" @cancel="handleClose">
        <div class="flex flex-col gap-2">
            <div>
                <label>{{ $t('ai.image.mask.label') }}</label>
                <ImageMasker :image="image" @change="handleMaskerChange" v-if="image"/>
            </div>
            <Input v-model="prompt" type="text" :label="$t('ai.image.mask.input.label')" :placeholder="$t('ai.image.mask.input.placeholder')"/>
        </div>
    </Modal>
</template>